diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java b/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java
index 97c6f6e9c..b35de9227 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java
@@ -2,178 +2,122 @@ package net.minecraft.core.world.weather;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
-import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.chunk.Chunk;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.PropertyKey;
 
 import java.util.Random;
 
-public abstract class Weather
-{
-	public int weatherId;
-	public String languageKey;
-	public boolean isPrecipitation = false;
-	private String texturePath = null;
-	public int subtractLightLevel = 0;
-	public int precipitationType = 0;
-	public boolean spawnRainParticles = false;
-	public boolean doMobsSpawnInDaylight = false;
-	public boolean isDamp = false;
-	public float fogDistance = 1.0f;
-	
-	public Weather(int id)
-	{
-		if(Weathers.WEATHERS[id] != null) throw new RuntimeException();
-		Weathers.WEATHERS[id] = this;
-		this.weatherId = id;
-	}
-	
-	public Weather setLanguageKey(String key)
-	{
-		languageKey = "weather." + key;
-		return this;
-	}
-	
-	public Weather setPrecipitation(String texturePath, int type)
-	{
-		this.isPrecipitation = true;
-		this.texturePath = texturePath;
-		this.precipitationType = type;
-		return this;
-	}
-	
-	public Weather setPrecipitationTexture(String texturePath)
-	{
-		this.texturePath = texturePath;
-		return this;
-	}
-
-	public String getPrecipitationTexture(World world)
-	{
-		return texturePath;
-	}
-	
-	public Weather setSubtractLightLevel(int subtractLightLevel)
-	{
-		this.subtractLightLevel = subtractLightLevel;
-		return this;
-	}
-	
-	public Weather setSpawnRainParticles(boolean spawnRainParticles)
-	{
-		this.spawnRainParticles = spawnRainParticles;
-		return this;
-	}
-	
-	public Weather setFogDistance(float f)
-	{
-		this.fogDistance = f;
-		return this;
-	}
-	
-	public Weather setMobsSpawnInDaylight()
-	{
-		doMobsSpawnInDaylight = true;
-		return this;
-	}
-
-	public Weather setDamp() {
-		isDamp = true;
-		return this;
-	}
-	
-	public String getTranslatedName()
-	{
-		return I18n.getInstance().translateKey(languageKey + ".name");
-	}
-	
-	public String getLanguageKey() {
-		return languageKey;
-	}
-	
-	public float[] modifyFogColor(float r, float g, float b, float intensity)
-	{
-		return new float[] { r, g, b };
-	}
-	
-	public void doEnvironmentUpdate(World world, Random rand, int x, int z)
-	{
-		if (world.getSeasonManager().getCurrentSeason() != null && !world.getSeasonManager().getCurrentSeason().letWeatherCleanUpSnow) return;
-
-		if (rand.nextInt(4) == 0)
-		{
-			int y = world.getHeightValue(x, z);
-
-			int blockId = world.getBlockId(x, y, z);
-			int blockIdBelow = world.getBlockId(x, y - 1, z);
-
-			if (world.getBlockBiome(x, y, z).hasSurfaceSnow())
-			{
-				if (blockId == Blocks.LAYER_SNOW.id())
-				{
-					int meta = world.getBlockMetadata(x, y, z);
-					if (meta != 0)
-					{
-						world.setBlockMetadata(x, y, z, meta - 1);
-						world.markBlockNeedsUpdate(x, y, z);
-					}
-				}
-			}
-			else
-			{
-				if (blockId == Blocks.LAYER_SNOW.id())
-				{
-					int meta = world.getBlockMetadata(x, y, z);
-					if (meta != 0)
-					{
-						world.setBlockMetadata(x, y, z, meta - 1);
-						world.markBlockNeedsUpdate(x, y, z);
-					}
-					else
-					{
-						world.setBlockWithNotify(x, y, z, 0);
-					}
-				}
-				else if (blockIdBelow == Blocks.ICE.id())
-				{
-					world.setBlockWithNotify(x, y - 1, z, Blocks.FLUID_WATER_STILL.id());
-				}
-			}
-		}
-	}
-
-	public void doChunkLoadEffect(World world, Chunk chunk)
-	{
-		if (world.getSeasonManager().getCurrentSeason() != null && !world.getSeasonManager().getCurrentSeason().letWeatherCleanUpSnow) return;
-
-		for (int x = 0; x < 16; x++)
-		{
-			for (int z = 0; z < 16; z++)
-			{
-				int y = chunk.getHeightValue(x, z);
-				if (y == 0) continue;
-
-				int blockId = chunk.getBlockID(x, y, z);
-				int blockIdBelow = chunk.getBlockID(x, y - 1, z);
-
-				if (world.getBlockBiome(chunk.xPosition * 16 + x, y, chunk.zPosition * 16 + z).hasSurfaceSnow())
-				{
-					if (blockId == Blocks.LAYER_SNOW.id())
-					{
-						chunk.setBlockMetadata(x, y, z, 0);
-					}
-				}
-				else
-				{
-					if (blockId == Blocks.LAYER_SNOW.id())
-					{
-						chunk.setBlockID(x, y, z, 0);
-					}
-					else if (blockIdBelow == Blocks.ICE.id())
-					{
-						chunk.setBlockID(x, y - 1, z, Blocks.FLUID_WATER_STILL.id());
-					}
-				}
-			}
-		}
-	}
+public abstract class Weather {
+    private final int id;
+    private final @NotNull String languageKey;
+    private final int lightLevelSubtracted;
+    private final boolean mobDaylightSpawnAllowed;
+    private final boolean isDamp;
+    private final float fogDistanceMultiplier;
+
+    public Weather(final int id, final @NotNull String languageKey, final @NotNull WeatherConfig weatherConfig) {
+        this.id = id;
+        this.languageKey = "weather." + languageKey;
+
+        this.lightLevelSubtracted = weatherConfig.getLightLevelSubtracted();
+        this.mobDaylightSpawnAllowed = weatherConfig.isMobDaylightSpawnAllowed();
+        this.isDamp = weatherConfig.isDamp();
+        this.fogDistanceMultiplier = weatherConfig.getFogDistanceMultiplier();
+
+        if (Weathers.WEATHERS[id] != null) throw new RuntimeException();
+        Weathers.WEATHERS[id] = this;
+    }
+
+    public final int getId() {
+        return this.id;
+    }
+
+    public final @NotNull String getLanguageKey() {
+        return this.languageKey;
+    }
+
+    public final @NotNull String getNameLanguageKey() {
+        return this.languageKey + ".name";
+    }
+
+    public final int getLightLevelSubtracted() {
+        return this.lightLevelSubtracted;
+    }
+
+    public final boolean isMobDaylightSpawnAllowed() {
+        return this.mobDaylightSpawnAllowed;
+    }
+
+    public final boolean isDamp() {
+        return this.isDamp;
+    }
+
+    public final float getFogDistanceMultiplier() {
+        return this.fogDistanceMultiplier;
+    }
+
+    public abstract float @NotNull [] modifyFogColor(final float r, final float g, final float b, final float intensity);
+
+    public void doEnvironmentUpdate(final @NotNull World world, final @NotNull Random rand, final int x, final int z) {
+        if (world.getSeasonManager().getCurrentSeason() != null && !world.getSeasonManager().getCurrentSeason().letWeatherCleanUpSnow)
+            return;
+
+        if (rand.nextInt(4) == 0) {
+            final int y = world.getHeightValue(x, z);
+
+            final int blockId = world.getBlockId(x, y, z);
+            final int blockIdBelow = world.getBlockId(x, y - 1, z);
+
+            if (world.getBlockBiome(x, y, z).hasSurfaceSnow()) {
+                if (blockId == Blocks.LAYER_SNOW.id()) {
+                    final int meta = world.getBlockMetadata(x, y, z);
+                    if (meta != 0) {
+                        world.setBlockMetadata(x, y, z, meta - 1);
+                        world.markBlockNeedsUpdate(x, y, z);
+                    }
+                }
+            } else {
+                if (blockId == Blocks.LAYER_SNOW.id()) {
+                    final int meta = world.getBlockMetadata(x, y, z);
+                    if (meta != 0) {
+                        world.setBlockMetadata(x, y, z, meta - 1);
+                        world.markBlockNeedsUpdate(x, y, z);
+                    } else {
+                        world.setBlockWithNotify(x, y, z, 0);
+                    }
+                } else if (blockIdBelow == Blocks.ICE.id()) {
+                    world.setBlockWithNotify(x, y - 1, z, Blocks.FLUID_WATER_STILL.id());
+                }
+            }
+        }
+    }
+
+    public void doChunkLoadEffect(final @NotNull World world, final @NotNull Chunk chunk) {
+        if (world.getSeasonManager().getCurrentSeason() != null && !world.getSeasonManager().getCurrentSeason().letWeatherCleanUpSnow) {
+            return;
+        }
+
+        for (int x = 0; x < 16; x++) {
+            for (int z = 0; z < 16; z++) {
+                int y = chunk.getHeightValue(x, z);
+                if (y == 0) continue;
+
+                int blockId = chunk.getBlockID(x, y, z);
+                int blockIdBelow = chunk.getBlockID(x, y - 1, z);
+
+                if (world.getBlockBiome(chunk.xPosition * 16 + x, y, chunk.zPosition * 16 + z).hasSurfaceSnow()) {
+                    if (blockId == Blocks.LAYER_SNOW.id()) {
+                        chunk.setBlockMetadata(x, y, z, 0);
+                    }
+                } else {
+                    if (blockId == Blocks.LAYER_SNOW.id()) {
+                        chunk.setBlockID(x, y, z, 0);
+                    } else if (blockIdBelow == Blocks.ICE.id()) {
+                        chunk.setBlockID(x, y - 1, z, Blocks.FLUID_WATER_STILL.id());
+                    }
+                }
+            }
+        }
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherClear.java b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherClear.java
index 1c1ffa3b5..d755c465b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherClear.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherClear.java
@@ -1,10 +1,14 @@
 package net.minecraft.core.world.weather;
 
-public class WeatherClear extends Weather
-{
-	public WeatherClear(int id)
-	{
-		super(id);
-	}
+import org.jetbrains.annotations.NotNull;
 
+public class WeatherClear extends Weather {
+    public WeatherClear(final int id, final @NotNull String languageKey, final @NotNull WeatherConfig weatherConfig) {
+        super(id, languageKey, weatherConfig);
+    }
+
+    @Override
+    public float @NotNull [] modifyFogColor(final float r, final float g, final float b, final float intensity) {
+        return new float[]{r, g, b};
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherConfig.java b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherConfig.java
new file mode 100644
index 000000000..811ab0793
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherConfig.java
@@ -0,0 +1,54 @@
+package net.minecraft.core.world.weather;
+
+
+import org.jetbrains.annotations.NotNull;
+
+public class WeatherConfig {
+    private int lightLevelSubtracted = 0;
+    private boolean mobDaylightSpawnAllowed = false;
+    private boolean isDamp = false;
+    private float fogDistanceMultiplier = 1.0f;
+
+    public WeatherConfig() {
+    }
+
+    public @NotNull WeatherConfig setLightLevelSubtracted(final int lightLevelSubtracted) {
+        this.lightLevelSubtracted = lightLevelSubtracted;
+
+        return this;
+    }
+
+    public int getLightLevelSubtracted() {
+        return this.lightLevelSubtracted;
+    }
+
+    public @NotNull WeatherConfig setMobDaylightSpawnAllowed(final boolean mobDaylightSpawnAllowed) {
+        this.mobDaylightSpawnAllowed = mobDaylightSpawnAllowed;
+
+        return this;
+    }
+
+    public boolean isMobDaylightSpawnAllowed() {
+        return this.mobDaylightSpawnAllowed;
+    }
+
+    public @NotNull WeatherConfig setDamp(final boolean isDamp) {
+        this.isDamp = isDamp;
+
+        return this;
+    }
+
+    public boolean isDamp() {
+        return this.isDamp;
+    }
+
+    public @NotNull WeatherConfig setFogDistanceMultiplier(final float fogDistanceMultiplier) {
+        this.fogDistanceMultiplier = fogDistanceMultiplier;
+
+        return this;
+    }
+
+    public float getFogDistanceMultiplier() {
+        return this.fogDistanceMultiplier;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherManager.java b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherManager.java
index 0170e655e..ec6ac3dcc 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherManager.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherManager.java
@@ -5,22 +5,24 @@ import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.season.Season;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class WeatherManager {
-    private final World world;
+    private final @NotNull World world;
 
-    private Weather lastWeather = null;
-    private Weather currentWeather = null;
-    private Weather nextWeather = null;
+    private @Nullable Weather lastWeather = null;
+    private @Nullable Weather currentWeather = null;
+    private @Nullable Weather nextWeather = null;
     private long weatherDuration = Global.DAY_LENGTH_TICKS;
     private float weatherIntensity = 1.0f;
     private float weatherPower = 1.0f;
 
-    public WeatherManager(World world) {
+    public WeatherManager(final @NotNull World world) {
         this.world = world;
     }
 
-    public WeatherManager(World world, Weather currentWeather, Weather nextWeather, long weatherDuration, float weatherIntensity, float weatherPower) {
+    public WeatherManager(final World world, final @Nullable Weather currentWeather, final @Nullable Weather nextWeather, final long weatherDuration, final float weatherPower) {
         this(world);
         this.currentWeather = currentWeather;
         this.nextWeather = nextWeather;
@@ -34,29 +36,32 @@ public class WeatherManager {
             this.weatherIntensity = 1.0f;
         }
     }
-    public Weather getLastWeather() { return lastWeather; }
 
-    public Weather getCurrentWeather() {
-        return currentWeather;
+    public @Nullable Weather getLastWeather() {
+        return this.lastWeather;
     }
 
-    public Weather getNextWeather() {
-        return nextWeather;
+    public @Nullable Weather getCurrentWeather() {
+        return this.currentWeather;
+    }
+
+    public @Nullable Weather getNextWeather() {
+        return this.nextWeather;
     }
 
     public long getWeatherDuration() {
-        return weatherDuration;
+        return this.weatherDuration;
     }
 
     public float getWeatherIntensity() {
-        return weatherIntensity;
+        return this.weatherIntensity;
     }
 
     public float getWeatherPower() {
-        return weatherPower;
+        return this.weatherPower;
     }
 
-    public void overrideWeather(Weather currentWeather, Weather nextWeather, long weatherDuration, float weatherIntensity, float weatherPower) {
+    public void overrideWeather(final @Nullable Weather currentWeather, final @Nullable Weather nextWeather, final long weatherDuration, final float weatherIntensity, final float weatherPower) {
         this.lastWeather = this.currentWeather;
         this.currentWeather = currentWeather;
         this.nextWeather = nextWeather;
@@ -65,109 +70,111 @@ public class WeatherManager {
         this.weatherPower = weatherPower;
     }
 
-    public void overrideWeather(Weather weather, long duration, float power) {
-        lastWeather = currentWeather;
-        currentWeather = weather;
-        nextWeather = null;
-        weatherDuration = duration;
-        weatherIntensity = 1.0f;
-        weatherPower = MathHelper.clamp(power, 0.0f, 1.0f);
+    public void overrideWeather(final @Nullable Weather weather, final long duration, final float power) {
+        this.lastWeather = this.currentWeather;
+        this.currentWeather = weather;
+        this.nextWeather = null;
+        this.weatherDuration = duration;
+        this.weatherIntensity = 1.0f;
+        this.weatherPower = MathHelper.clamp(power, 0.0f, 1.0f);
     }
 
-    public void overrideWeather(Weather weather, long duration) {
+    public void overrideWeather(final @Nullable Weather weather, final long duration) {
         this.overrideWeather(weather, duration, getRandomWeatherPower());
     }
 
-    public void overrideWeather(Weather weather) {
+    public void overrideWeather(final @Nullable Weather weather) {
         this.overrideWeather(weather, getRandomWeatherDuration());
     }
 
     public void skip() {
-        weatherDuration = 0;
+        this.weatherDuration = 0;
     }
 
     public boolean tick() {
-        if(world.worldType.hasCeiling())
-        {
+        if (this.world.getWorldType().hasCeiling()) {
             return false;
         }
-        if (world.getSeasonManager().getCurrentSeason() == null)
+        if (this.world.getSeasonManager().getCurrentSeason() == null)
             return false;
 
-        if (currentWeather == null) {
-            lastWeather = null;
-            currentWeather = world.worldType.getDefaultWeather();
-            weatherDuration = getRandomWeatherDuration();
+        if (this.currentWeather == null) {
+            this.lastWeather = null;
+            this.currentWeather = this.world.getWorldType().getDefaultWeather();
+            this.weatherDuration = getRandomWeatherDuration();
         }
 
-        if (nextWeather == null && weatherIntensity <= 1.0f)
-        {
-            weatherIntensity += 0.002f;
-            if (weatherIntensity > 1.0f)
-                weatherIntensity = 1.0f;
-        }
-        else if (nextWeather != null && weatherIntensity >= 0.0f)
-        {
-            weatherIntensity -= 0.002f;
-            if (!world.isClientSide) {
-                if (world.dayCanHaveRainbow && world.rainbowTicks <= 0 && weatherIntensity < 0.5f && currentWeather.precipitationType == 0 && !nextWeather.isPrecipitation){ // On rain end
-                    int rainbowTicks = world.rand.nextInt(20 * 90) + 20 * 30;
-                    world.addRainbow(rainbowTicks);
+        if (this.nextWeather == null && this.weatherIntensity <= 1.0f) {
+            this.weatherIntensity += 0.002f;
+            if (this.weatherIntensity > 1.0f)
+                this.weatherIntensity = 1.0f;
+        } else if (this.nextWeather != null && this.weatherIntensity >= 0.0f) {
+            this.weatherIntensity -= 0.002f;
+            if (!this.world.isClientSide) {
+                if (this.currentWeather instanceof IPrecipitation) {
+                    final @NotNull IPrecipitation precipitation = (IPrecipitation) this.currentWeather;
+                    if (this.world.dayCanHaveRainbow &&
+                        this.world.rainbowTicks <= 0 &&
+                        this.weatherIntensity < 0.5f &&
+                        precipitation.getPrecipitationType() == IPrecipitation.Type.RAIN_LIKE &&
+                        !(this.nextWeather instanceof IPrecipitation)
+                    ) { // On rain end
+                        final int rainbowTicks = this.world.rand.nextInt(20 * 90) + 20 * 30;
+                        this.world.addRainbow(rainbowTicks);
+                    }
                 }
             }
-            if (weatherIntensity <= 0.0f) {
-                weatherIntensity = 0.0f;
-                lastWeather = currentWeather;
-                currentWeather = nextWeather;
-                weatherPower = getRandomWeatherPower();
-                nextWeather = null;
+            if (this.weatherIntensity <= 0.0f) {
+                this.weatherIntensity = 0.0f;
+                this.lastWeather = this.currentWeather;
+                this.currentWeather = this.nextWeather;
+                this.weatherPower = getRandomWeatherPower();
+                this.nextWeather = null;
             }
         }
 
-        if (world.getGameRuleValue(GameRules.DO_WEATHER_CYCLE)) {
-            weatherDuration--;
+        if (this.world.getGameRuleValue(GameRules.DO_WEATHER_CYCLE)) {
+            this.weatherDuration--;
         }
-        if (weatherDuration <= 0)
-        {
-            if (currentWeather != world.worldType.getDefaultWeather()) {
-                nextWeather = world.worldType.getDefaultWeather();
+        if (this.weatherDuration <= 0) {
+            if (this.currentWeather != this.world.getWorldType().getDefaultWeather()) {
+                this.nextWeather = this.world.getWorldType().getDefaultWeather();
             } else {
-                Season season = world.getSeasonManager().getCurrentSeason();
+                final @NotNull Season season = this.world.getSeasonManager().getCurrentSeason();
                 boolean foundWeather = false;
                 float acc = 0.0f;
-                float val = world.rand.nextFloat();
+                final float val = this.world.rand.nextFloat();
                 for (int i = 0; i < season.allowedWeathers.size(); i++) {
                     acc += season.weatherProbability.get(season.allowedWeathers.get(i));
                     if (val < acc) {
-                        nextWeather = season.allowedWeathers.get(i);
+                        this.nextWeather = season.allowedWeathers.get(i);
                         foundWeather = true;
                         break;
                     }
                 }
                 if (!foundWeather) {
-                    nextWeather = world.worldType.getDefaultWeather();
+                    this.nextWeather = this.world.getWorldType().getDefaultWeather();
                 }
 
             }
-            weatherDuration = getRandomWeatherDuration();
+            this.weatherDuration = getRandomWeatherDuration();
         }
 
-        world.dimensionData.setCurrentWeather(currentWeather);
-        world.dimensionData.setNextWeather(nextWeather);
+        this.world.dimensionData.setCurrentWeather(this.currentWeather);
+        this.world.dimensionData.setNextWeather(this.nextWeather);
 
-        world.dimensionData.setWeatherDuration(weatherDuration);
-        world.dimensionData.setWeatherIntensity(weatherIntensity);
-        world.dimensionData.setWeatherPower(weatherPower);
+        this.world.dimensionData.setWeatherDuration(this.weatherDuration);
+        this.world.dimensionData.setWeatherIntensity(this.weatherIntensity);
+        this.world.dimensionData.setWeatherPower(this.weatherPower);
 
         return true;
-
     }
 
     private long getRandomWeatherDuration() {
-        return (long)(world.rand.nextFloat() * (Global.DAY_LENGTH_TICKS * 1.5f) + (Global.DAY_LENGTH_TICKS * 0.25f));
+        return (long) (this.world.rand.nextFloat() * (Global.DAY_LENGTH_TICKS * 1.5f) + (Global.DAY_LENGTH_TICKS * 0.25f));
     }
 
     private float getRandomWeatherPower() {
-        return world.rand.nextFloat() * 0.5f + 0.5f;
+        return this.world.rand.nextFloat() * 0.5f + 0.5f;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherRain.java b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherRain.java
index b130c85a7..f1d18e9fd 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherRain.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherRain.java
@@ -1,22 +1,34 @@
 package net.minecraft.core.world.weather;
 
-public class WeatherRain extends Weather
-{
+import org.jetbrains.annotations.NotNull;
 
-	public WeatherRain(int id)
-	{
-		super(id);
-	}
-	
-	@Override
-	public float[] modifyFogColor(float r, float g, float b, float intensity)
-	{
-		float f6 = 1.0F - intensity * 0.5F;
-        float f8 = 1.0F - intensity * 0.4F;
-        r *= f6;
-        g *= f6;
-        b *= f8;
-        
-        return new float[] { r, g, b };
-	}
+public class WeatherRain
+    extends Weather
+    implements IPrecipitation {
+    public WeatherRain(final int id, final @NotNull String languageKey, final @NotNull WeatherConfig weatherConfig) {
+        super(id, languageKey, weatherConfig);
+    }
+
+    @Override
+    public float @NotNull [] modifyFogColor(final float r, final float g, final float b, final float intensity) {
+        final float rgMod = 1.0F - intensity * 0.5F;
+        final float bMod = 1.0F - intensity * 0.4F;
+
+        return new float[]{r * rgMod, g * rgMod, b * bMod};
+    }
+
+    @Override
+    public @NotNull Type getPrecipitationType() {
+        return Type.RAIN_LIKE;
+    }
+
+    @Override
+    public @NotNull String getPrecipitationTexturePath(final float power, final float intensity) {
+        return "/assets/minecraft/textures/environment/rain.png";
+    }
+
+    @Override
+    public boolean spawnRainParticles() {
+        return true;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherRainBlood.java b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherRainBlood.java
new file mode 100644
index 000000000..23a65e693
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherRainBlood.java
@@ -0,0 +1,19 @@
+package net.minecraft.core.world.weather;
+
+import org.jetbrains.annotations.NotNull;
+
+public class WeatherRainBlood extends WeatherStorm {
+    public WeatherRainBlood(final int id, final @NotNull String languageKey, final @NotNull WeatherConfig weatherConfig) {
+        super(id, languageKey, weatherConfig);
+    }
+
+    @Override
+    public @NotNull Type getPrecipitationType() {
+        return Type.INVERTED_RAIN_LIKE;
+    }
+
+    @Override
+    public @NotNull String getPrecipitationTexturePath(final float power, final float intensity) {
+        return "/assets/minecraft/textures/environment/rain_blood.png";
+    }
+}
